/**
 * * Copyright (c) 2018. Honeywell International, Inc. All Rights Reserved.
 */


define(['baja!',
        'jquery'],
    function (Baja,
              $) {

        'use strict';

        /**
         * Description of your widget.
         *
         * @class
         * @alias module:nmodule/trendMigration/rc/js/migration/MigrationSelectView
         */
        var someView = new function(){

            //define local variables and functions

            return {


                /**
                 *
                 * @param element: dom element the view will be added to
                 * @param params: javascript object with widget parameters required to load the view within the widget
                 */

                loadView : function(element, params) {
                },

                /**
                 * validate user input
                 *
                 * @returns {boolean}: return true/false based on validity of user input
                 */
/*
                validate: function() {
                    //TODO: validate user input
                    return true;
                },
*/

                /**
                 * clean up and save before going to next view
                 *
                 * @returns {Promise}: return promise to be resolved before going to next view
                 */
                next : function() {
                 return new Promise(function(resolve){
                        //TODO:task to do before moving to next screen
                     resolve();
                 });
                 },

                /**
                 * clean up and save before going to previous view
                 *
                 */
                back : function() {
                 return new Promise(function(resolve){
                        //TODO:task to do before moving to previous screen
                     resolve();
                 });
                },

                /**
                 * cancel operation
                 *
                 */
/*
                cancel: function() {
                    //TODO: cancel running operation within current view
                },
*/

                /**
                 * data to be passed to widget to communicate between views
                 *
                 * @returns {json}: return key value pairs of data
                 */
                getData: function() {
                    //TODO: task to update data to be passed to widget
                    return {};
                },


                /**
                 * enable/disable status of visisble action buttons within the view
                 *
                 * @returns {json}: return action buttons status (enabled/disabled)
                 */
/*
                //Note: by default all buttons within the view are enabled.
                // uncomment and update the code to conditionally enable or disable action buttons
                enableDisableActionBttns: function () {
                //TODO: update action buttons status
                    return {
                        disabledBack : false,
                        disabledNext : false,
                        disabledCancel:false
                    };
                },
*/
                params:{
                    vname:'someView',
                    id:'someView',
                    icon:"/path/to/someViewIcon.svg",
                    message:'some_lexiconized_message',
                    backBttnMsg: '< Back',
                    nextBttnMsg: ' Next >',
                    isCancelAvailable:false
                }
            };
        };

        return someView;
    });